package de.jcg.Persistence;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;



import de.jcg.Trainer.Vokabel;


public class Database {

	// Singleton for multithreading Extension, initialized by JVM
	private final static Database instance = new Database();
	public final String HOME = System.getProperty("user.home")
			+ System.getProperty("file.separator") + "Vokabeltrainer";

	private List<Vokabel> voc;
	private List<Vokabel> toSave = new ArrayList<Vokabel>();
    
	private static int numberAnswers;
	private static int allQuestionsNumber;
	private int selectedIndex;
	
	
	private Database(){
		
	}
	
	public static Database getInstance() {
		return instance;
	}
	
	public void saveToRAM(String voc, String trans){
		// Hier wird temporr gespeichert
	
		
	}
	
	public void delFromRAM(String voc, String trans){
		// aus dem temporren Speicher lschen
	}
	
	public void saveToCSV(String name) {
		// hier wird in die CSV gespeichert
		
		
		
		
		// ab hier nicht mehr ndern
		toSave = new ArrayList<Vokabel>();
	}
	
	public void readFromCSV(String name, boolean language, int number){
		Database.setNumberAnswers(number);
		Database.setAllQuestionsNumber(number);
		voc = new ArrayList<Vokabel>();
		// AB HIER CODE SCHREIBEN, darber nichts ndern
		
		
		
	
	}
	

	public String[] getAllFiles(){
		if(new File(HOME).list().length > 0)
			return new File(HOME).list();
		else
			return new String[]{""};
	}
	

	public void readRandomFromCSV(String name, boolean language, int number){
		String[] currentVocAndTranslation;
		try {
			RandomAccessFile bla = new RandomAccessFile(new File(HOME+System.getProperty("file.separator")+name), "r");
			char[] chars = new char[50];
			int currentPosition, a = 0;
			long pos;
			
			for (int i = 0; i < number; i++) {
				pos = (int) (Math.random()*bla.length());
				System.out.println("Pos: "+pos);
				bla.seek(pos);
				currentPosition = bla.read(); 
				
				while((pos != 0) && ((char)currentPosition != '*'))
					bla.seek(--pos);
				while(((currentPosition = bla.read()) != (int)'*')&& (currentPosition != -1)){
					chars[a] = (char) currentPosition;
				}
				currentVocAndTranslation = chars.toString().split(";");
				if(language)
					voc.add(new Vokabel(currentVocAndTranslation[0], currentVocAndTranslation[1]));
				else
					voc.add(new Vokabel(currentVocAndTranslation[1], currentVocAndTranslation[0]));
			}
			bla.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.getMessage();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
	public List<Vokabel> getVoc() {
		return voc;
	}

	public static void setNumberAnswers(int numberAnswers) {
		Database.numberAnswers = numberAnswers;
	}

	public static int getNumberAnswers() {
		return numberAnswers;
	}
	
	private void printVoc(){
		for (Vokabel currentString : voc) {
			System.out.println(currentString.getVoc() + currentString.getTranslation());
		}
	}

	public static void setAllQuestionsNumber(int allQuestionsNumber) {
		Database.allQuestionsNumber = allQuestionsNumber;
	}

	public static int getAllQuestionsNumber() {
		return allQuestionsNumber;
	}

	public void setSelectedIndex(int selectedIndex) {
		this.selectedIndex = selectedIndex;
	}

	public int getSelectedIndex() {
		return selectedIndex;
	}
	
	
}
